﻿// Copyright (c) 2006 Google Inc.
// All rights reserved
// 
// This file is part of the Google Desktop SDK and may be freely copied and used.
// To download the latest version of the SDK please visit 
// http://desktop.google.com/developer.html

// In this sample the gadget will show a list of online friends and their
// status. When you click on a name, the gadget will send a string of data
// to this same gadget running on that friend's sidebar, where it will
// be handled and displayed on the screen. Also, when you double-click on a
// name, a Google Talk chat window will open with that friend with some
// initial text.

// To try out this gadget, you'll need a pair of Sidebars, Google Talks, and
// Google Talk accounts that have each other as friends. This can be done
// using two computers or simply with a friend.

function view_onopen() {
  // Set up Google Talk data handler
  //googleTalk.onReceiveTalkData = OnDataArrival;
  // Update friends list for the first time
//  updateFriends();
  generateToken();
  first();
  
  // Continue updating every 10 seconds
  //setInterval(updateFriends, kUpdateFriendsInterval);
}


//NEW
options.defaultValue("saved") = "false";
debug.trace('saved:' + options("saved"));
var token = 'DEFAULT_TOKEN_PLEASE_REPLACE';
var wasSaved = 'false';
var justSaved = false;
var count = 0;
var trail = '';
var DNA   = '';
var USE_IMAGES   = true;
var dnaNameShort = 'TAG';
var dnaNameLong  = 'Mood Tag';

var baseUrl  	 = 'http://www.chaosindex.com/whoweare';
var tokenSaveTagUrl  = baseUrl + '/token-save-tag.jsp?token='+token;
var tokenGetTagUrl   = baseUrl + '/token-get-tag.jsp?token='+token;
var moodMatchUrl     = baseUrl + '/moodmatch.jsp';
var imageUrl         = 'symbol';

var imagePool = [
			'1','01-50px',
			'2','02-50px',
			'3','03-50px',
			'4','04-50px',
			'5','05-50px',
			'6','06-50px',
			'7','07-50px',
			'8','08-50px',
			'9', '09-50px',
			'10','10-50px',
			'11','11-50px',
			'12','12-50px'
            ];
var imagePoolDescription = [
			'1','small',
			'2','large',
			'3','binary',
			'4','decimal',
			'5','blue',
			'6','green',
			'7','square',
			'8','triangle',
			'9', 'catus',
			'10','rose',
			'11', 'ocean',
			'12', 'mountain'
            ];
// end NEW

// Interval for updating the friends list, in ms
var kUpdateFriendsInterval = 10000; // 10 seconds

//+++ for testing of friends in offline mode 
function myFriend(i) {
//alert('fr');
  this.user_id = 'user id ' + i;
  this.name = 'friend name ' + i ;
  this.status = 'Away';
}

function myFriends() {
//alert('frs');
  this.friends = new Array();
  for (var i=0; i<3; i++) {
   var fr = new myFriend(i);
   this.friends[i] = fr;
  }
}
//+++ END for testing of friends in offline mode 

// friends variables
var frTotalPages = 1;
var frCurPage    = 0;
var frNextPage   = 1;
var frsUpper     = 0;
var frsPerPage   = 5;


// Update the list of friends in the UI
function updateFriends() {
//alert('0');

// Real
   frs = googleTalk.friends;
   frsUpper = frs.ubound() + 1;
debug.trace('frsUpper '+ frsUpper);
// Testing
//  frs = new myFriends();  // for testing only
//  frsUpper = frs.friends.length;

  displayFriends();
}

function displayFriends() {
  // Delete all friends at once
  var count = container.children.count;
  while(count--) {
    var child = container.children(count);
    container.removeElement(child);
  }
  // Add children to the container div that represent the user's Google Talk
  // friends list
  
  // This is one way of iterating through the friends list. Another way is to
  // first convert the friends list to a JavaScript array and access it
  // using normal JavaScript array semantics:
  //  var frs = googleTalk.friends.toArray();
  //  for(var i = 0; i < frs.length; i++) {
  //    var fr = frs[i];
  //    // Do something with fr here...
  //  }
 
  var y = 0;
  container.appendElement('<label enabled="false" x="5" y="5" width="250" height="30">double-click a friend to send your Mood</label>');
  y += 20; container.appendElement('<label enabled="false" x="5" y="'+y+'" width="200" height="25" size="10" bold="false">'+DNA+'</label>');
  y += 25;

    
// how many pages?
  frTotalPages = frsUpper / frsPerPage;
debug.trace("frTotalPages " + frTotalPages);
debug.trace("frNextPage " + frNextPage);
debug.trace("frsPerPage " + frsPerPage);
  y = displayFriendsPage(frs,frNextPage,y);
  y += 10;
  if ( frCurPage > 1) { // rev
    container.appendElement('<a enabled="true" x="5" y="'+y+'" width="50" height="25" onclick="prevFriendsPage('+count+')">[prev]</a>');
  }
  if ( frCurPage < frTotalPages) { //next
    container.appendElement('<a enabled="true" x="100" y="'+y+'" width="50" height="25" onclick="nextFriendsPage('+count+')">[next] </a>');
  }
  y += 15; container.appendElement('<a enabled="true" x="5" y="'+y+'" width="200" height="25" onclick="writeSymbols('+count+')">Back to the MoodMeter...</a>');

}

function displayFriendsPage(frs,page,y)
{  
// TESTING only
//var lower = 0;
//var upper = frs.friends.length;

// REAL
  var lower = frs.lbound()
  var upper = frs.ubound()+1;

debug.trace("upper " + upper);
debug.trace("lower " + lower);
debug.trace("page " + page);
debug.trace("start idx " + ((page-1) * frsPerPage));

  for (var i = ((page-1) * frsPerPage); i < upper; i++, y += 15) {
    if ( i >= (page * (frsPerPage))) break;
    // REAL 
    var fr = frs.getItem(lower+i);
    // TESTING var fr = frs.friends[lower+i];
    // Dynamically create the link element representing a friend
    var el = container.appendElement('<a x="5" y="' + y + '" width="245" ' +
      'color="#000080" font="Tahoma" size="10" ' +
      'onclick="OnClick(\'' + fr.user_id + '\')" ' +
      'ondblclick="OnDblClick(\'' + fr.user_id + '\')"/>');
    el.tooltip = SEND_MESSAGE_PREFIX + fr.user_id;
    el.innerText = fr.name + ' (' + strings['TALK_STATUS_' + fr.status] + ')';
  }
  frCurPage = page;
debug.trace("frCurPage " + frCurPage);

  return y;
}

function nextFriendsPage(count)
{
 frNextPage = frCurPage+1;
 displayFriends();
}
function prevFriendsPage(count)
{
 frNextPage = frCurPage-1;
 displayFriends();
}


// NEW
function first() {
//alert('2');
	wasSaved = options("saved"); // indicator if was saved earlier
	justSaved = false;
	token = options("token"); // should be set at this point of time
	count = 0;
	trail = '';
	DNA   = '';
	tokenSaveTagUrl  = baseUrl + '/token-save-tag.jsp?token='+token;
	tokenGetTagUrl   = baseUrl + '/token-get-tag.jsp?token='+token;

	writeSymbols(count);
}


// create a unique token for this computer/user installation (once)
function generateToken()
{
  var storedToken = options("token");
gadget.debug.trace(storedToken);
  var a,b,n=1;
  if (storedToken == undefined) {
    a = Math.random().toString(16).substring(2);

    while (a!=b && n<16) {
      b=a;
      a = Math.random().toString(16).substring(2);
      n++;
    };
    storeToken = a;
    options("token") = storeToken;
  }
gadget.debug.trace(storedToken);
gadget.debug.trace(a+' (value)');
gadget.debug.trace(n+' (number of strings tested)');
}




function writeSymbols(index)
{
  // Delete all at once
  var childCount = container.children.count;
  while(childCount--) {
    var child = container.children(childCount);
    container.removeElement(child);
  }
  if (count < imagePool.length ) {

	var leftIdx  = index+1;
	var rightIdx = index+3;

	container.appendElement('<label enabled="false" x="5" y="10" width="210" height="30">Choose one image without thinking...</label>');
	container.appendElement('<img enabled="true" x="50" y="30" width="50" height="50" src="'+ imageUrl + imagePool[leftIdx] + '.jpg" onclick="choose('+leftIdx+');"/>');
	container.appendElement('<img enabled="true" x="110" y="30" width="50" height="50" src="'+ imageUrl + imagePool[rightIdx] + '.jpg" onclick="choose('+rightIdx+');"/>');
	
//	container.appendElement('<label enabled="false" x="5" y="60" width="200" height="30">'+DNA+'</label>');
//	if (wasSaved != "false") {
//	  container.appendElement('<a name="retrievelink" enabled="true" x="5" y="110" width="200" height="30" onclick="readTokenTag()">read previous Tag</a>');
//	}
  }
   else {
        var y = 10; container.appendElement('<label enabled="false" x="5" y="'+y+'" width="200" height="20">Your Mood Tag is</label>');
	y += 15; container.appendElement('<label enabled="false" x="5" y="'+y+'" width="200" height="44" size="26" bold="true">'+DNA+'</label>');
	y += 50;
	var num = 1;
	if (!justSaved) {
	  container.appendElement('<a enabled="true" x="5" y="'+y+'" width="200" height="15" tooltip="sends Mood anonymously so we can calculate the WorldMood!" onclick="saveTokenTag()">'+num+') send to WorldMood server...</a>');
	  y += 15;
	  num++;
	}
	container.appendElement('<a enabled="true" x="5" y="'+y+'" width="200" height="20" tooltip="has your Mood changed? Then do it again." onclick="first()">'+num+') do it again...</a>');
	num++;y += 15; container.appendElement('<a enabled="true" x="5" y="'+y+'" width="200" height="20" tooltip="see who is online then send your Mood" onclick="friends()">'+num+') your friends ...</a>');
	num++;y += 15; container.appendElement('<a enabled="true" x="5" y="'+y+'" width="200" height="20" tooltip="compare your Mood with the WorldMood" href="'+moodMatchUrl+'?TAG='+DNA+'">'+num+') go to MoodMatcher...</a>');
	//y += 35; container.appendElement('<edit enabled="true" x="5" y="'+y+'" width="300" height="20" name="matchtag" value="type friends tag and click submit" background="#CCCCCC" onkeypress="edit_onkeypress()"/>');
   }
}

function edit_onkeypress()
    {
      alert(event.keyCode); if( event.keyCode == 'j' ) event.returnValue = false;
    }

function choose( selected )
{
 //incTrail(selected);
 count = count + 4;
 DNA   = DNA + imagePool[selected-1];
 writeSymbols(count);
}

function saveTokenTag()
{
  var url = tokenSaveTagUrl+ '&TAG=' + DNA;
  debug.trace('save ' + url);
  saveToWeb(url);
  justSaved = true;
  writeSymbols(count);
}

// TBD
function readTokenTag()
{
  var url = tokenGetTagUrl;
  debug.trace('read ' + url);
  //readFromWeb(url);
}

function friends()
{
 updateFriends();
}

// end NEW



// Handler for incoming Google Talk data
function OnDataArrival(talk_friend, data) {
  alert('Data from ' + talk_friend.name +
    ' (' + talk_friend.user_id + '):\n\n' + data);
}

// Handler for clicks on the user links
function OnClick(talk_user_id) {
  // This sends arbitrary data to the counterpart gadget on a friend's sidebar.
  // Note that if the sidebar is closed, or the gadget isn't active, the user
  // is prompted to open the sidebar or install the gadget. In most cases,
  // such as sending a news item, this is desirable. If, however, you wish
  // message delivery to fail silently, you can use the following syntax:
  //  googleTalk.SendTalkDataEx(talk_user_id, 'Data here...',
  //    gddSendDataFlagSilent);
  googleTalk.SendTalkData(talk_user_id, 'MoodTag ' + DNA);
}

// Handler for double-clicks on the user links
function OnDblClick(talk_user_id) {
  // This opens a Google Talk conversation window with the specified friend
  googleTalk.SendTalkText(talk_user_id, 
    'MoodMeter Gadget has sent this Mood Tag to you: '+DNA+'  \n MoodCheck? Click link '+moodMatchUrl+'?TAG='+DNA);
}


//--------- Save and Read
//---- A class to manage the requests and callbacks of an item
function saveToWeb(url) {
  // send request to webserver for data
  //var source = GetDomainName(url);
  var http = new XMLHttpRequest();
  http.onreadystatechange = OnData;
  http.open("GET", url, true);
  http.send();

  function OnData() {
    if (http.readyState == 4) { // completed?
debug.trace('saved!');
      options("saved") = "true";
      http = null;  // free the http object
    }
  }
}


